from common.utils import XmlHttpResponse, JsonHttpResponse
from common.views import login_required

from vops.models import PolicyConstants, PolicyManager

manager = PolicyManager()
constants = PolicyConstants()

@login_required
def policies(request):
    return XmlHttpResponse(manager.list())
    
@login_required
def policies_save(request):
    return JsonHttpResponse(manager.save(request.POST.get('policies', None)))

@login_required
def policies_templates(request):   
    return JsonHttpResponse(manager.templates())
    
@login_required
def policies_constants(request, key=None):
    return JsonHttpResponse(constants.export(key) if key else constants.export())
