Ext.onReady(function(){
	$.jqplot.config.enablePlugins = true;
	
	var viewport = new Ext.Viewport({
		layout: 'fit',
		items: [{
			xtype: 'grouptabpanel',
			tabWidth: 140,
			activeGroup: 0,
			items: [{
				mainItem: 0,
				id: 'grouptabpanel-dashboard',
				items: [
				// monitoring
				{
					title: 'Notifications',
					layout: 'fit',
					iconCls: 'x-icon-notifications',
					style: 'padding: 10px;',
					items: [
						notificationGrid
					]
				}
				,{		
					title: 'Rules',
					iconCls: 'x-icon-rules',
					style: 'padding: 10px;',
					layout: 'fit',
					items: [
						ruleGrid
					]
				}
				, {
					title: 'Charts',
					layout: 'fit',
					iconCls: 'x-icon-charts',
					style: 'padding: 10px;',
					id: 'grouptabpanel-charts',
					items: [
						charts
					]
				}
				,{
					title: 'Map',
					layout: 'fit',
					iconCls: 'x-icon-map',
					tabTip: 'Map',
					style: 'padding: 10px;',
					id: 'grouptabpanel-map',
					items: [
						map
					]
				}]
			}
			// auditing
			,{
				expanded: true,
				items: [{
					title: 'Auditing',
					iconCls: 'x-icon-rules',
					tabTip: 'Rules',
					style: 'padding: 10px;',
					layout: 'fit',
					items: App.Auditing.Rules
				}
				,{
					title: 'Data',
					iconCls: 'x-icon-data',
					tabTip: 'Rules',
					style: 'padding: 10px;',
					layout: 'fit',
					items: App.Auditing.Data
				}]
			}
			// management
			,{
				expanded: true,
				items: [
		        {
					title: 'Resources',
					iconCls: 'x-icon-resources',
					tabTip: 'Resources',
					style: 'padding: 10px;',
					layout: 'fit',
					items: resources
				}
				,{
					id: 'dixi-nodes',
					title: 'Nodes',
					iconCls: 'x-icon-nodes',
					style: 'padding: 10px;',
					layout: 'fit',
					items: [
					    App.Dixi.Nodes
					]
				}
				,{
					id: 'vops-policies',
					title: 'Policies',
					iconCls: 'x-icon-policies',
					style: 'padding: 10px;',
					layout: 'fit',
					items: [
			        	App.Vops.Policies
					]
				}]
			}
			// user
			,{
				expanded: true,
				items: [{
					id: 'user-logout',
					title: 'Logout',
					iconCls: 'x-icon-key',
					tabTip: 'Click here to log out',
					style: 'padding: 10px;'
				} ],
				listeners: {
					beforetabchange: function(p, i){
						if(i.id == 'user-logout'){
							window.location = '/logout';
							return false;
						}
					},
					scope: this
				}
			}]
		}]
	});
});