Ext.onReady(function() {	
	App.Dixi.Nodes = new App.Dixi.TabPanel();
	
	// control nodes info buttons
	App.Dixi.Nodes.getGrid().on('rowclick', function(grid, rowIndex) {
		var nodes = grid.getSelectionModel().getSelections();
		var toolbar = App.Dixi.Nodes.getActiveTab().items.get(0).getTopToolbar()
		var info = toolbar.items.get(1);
	    var location = toolbar.items.get(2);
		
		if (nodes.length) {
			info.enable();
			location.enable();
		}
		else {
			info.disable();
			location.disable();
		}
	});
	
	// open service list
	App.Dixi.Nodes.getGrid().on('rowdblclick', function(grid, rowIndex) {
		var rowsSelected = grid.getSelectionModel().getSelections();
		var service = new App.Dixi.ServicesGrid();
		
		service.addListener('rowclick', function(grid, rowIndex) {
			var services = grid.getSelectionModel().getSelections();
			var toolbar = App.Dixi.Nodes.getActiveTab().items.get(0).getTopToolbar()
			var restart = toolbar.items.get(1);
		    var start = toolbar.items.get(2);
			var stop = toolbar.items.get(3);
			
			if (services.length) {
				restart.enable();
				start.enable();
				stop.enable();
			}
			else {
				restart.disable();
				start.disable();
				stop.disable();
			}
		});
		
		var store = service.store;
		var address = rowsSelected[0].data.address
		var id = rowsSelected[0].id
		
		store.baseParams = { action: 'filter', node_id: id };
		store.load();
		
		App.Dixi.Nodes.add({
            title: address
            ,id: 'dixi-services-' + id
            ,layout: 'fit'
            ,closable:true
            ,items: service
        }).show();
	});
	
	// get selected node info
	App.Dixi.Nodes.on('nodes-info', function() {
		var node = App.Dixi.Nodes.getGrid().getSelectionModel().getSelected();

		if (node) {				
            var win = new Ext.Window({
            	id: 'nodes-services-info-window'
        		,title: 'Resources'
				,frame: true
				,modal: true
				,border: false	
                ,width: 680
                ,height: 140
                ,items: [
					new Ext.grid.GridPanel({
						autoScroll: true
						,frame: false
						,enableHdMenu: false
						,height: 280
						,loadMask: { msg: "Please wait..." }
			    		,store: new Ext.data.JsonStore({
			    			successProperty: 'success'
		        			,root: 'data'
		    				,autoLoad: true
			    			,fields: [
	    			          	{ name: 'cpuLoadLast1min' }
					            ,{ name: 'cpuLoadLast5min' }
					            ,{ name: 'cpuLoadLast15min' }
					            ,{ name: 'operatingSystemName' }
					            ,{ name: 'processorArchitecture' }
					            ,{ name: 'CPUSpeed' }
					            ,{ name: 'CPUCount' }
					            ,{ name: 'RAMSize' }
			    			]
			    			,baseParams: {
			    				action: 'info'
			    				,node: node.data.address
							}
			    			,proxy: new Ext.data.HttpProxy({
			    				url: '/dixi/services/info'
			    			})
			    		})
			    		,columns: [
			    		    {header: 'OS', dataIndex: 'operatingSystemName'}
			    		    ,{header: 'Arch', dataIndex: 'processorArchitecture'}
	    	    		    ,{header: 'CPUSpeed', dataIndex: 'CPUSpeed'}
	    	    		    ,{header: 'CPUCount', dataIndex: 'CPUCount'}
			    		    ,{header: 'CPULoad 1min', dataIndex: 'cpuLoadLast1min'}
			    		    ,{header: 'CPULoad 5min', dataIndex: 'cpuLoadLast5min'}
			    		    ,{header: 'CPULoad 15min', dataIndex: 'cpuLoadLast15min'}
		    	    		,{header: 'RAMSize', dataIndex: 'RAMSize'}
	    	    		]
			    		,viewConfig: {
			    			forceFit: true
			    		}
					})
				]
                ,buttons: [
                    {
                    	text: 'Close'
            			,handler: function() {
	    					Ext.getCmp('nodes-services-info-window').close();
                		}
                	}
            	]
            });
            
            win.show(this);
		}
	});

	// show node location
	App.Dixi.Nodes.on('nodes-location', function() {
		var node = App.Dixi.Nodes.getGrid().getSelectionModel().getSelected();

        if (node) {		
		    var marker = null;
			var win = new Ext.Window({
			    id: 'nodes-services-location-window'
                ,layout: 'fit'
                ,title: 'Location'
 				,frame: true
				,modal: true
				,border: true
                ,width: 720
                ,height: 520
                ,items: {
                    xtype: 'gmappanel'
                    ,zoomLevel: 2
                    ,gmapType: 'map'
                    ,mapConfOpts: ['enableScrollWheelZoom','enableDragging']
                    ,mapControls: ['GSmallMapControl','GMapTypeControl','NonExistantControl']
                    ,setCenter: { lat: 10, lng: 0 }
                }
             	,buttons: [
 	                {
                       	text: 'Save'
                       	,hidden: true
               			,handler: function() {
	    					var position = marker.getPosition();
   	    					Ext.getCmp('nodes-services-location-window').close();
 	                	
		 	       			Ext.Ajax.request({
			 	   				url: '/dixi/nodes/location/save'
			 	   				,params: { node: node.data.address, lat: position.lat(), lng: position.lng() }
			 	   				,success: function(data) { 
			 	   					var data = Ext.util.JSON.decode(data.responseText);
			 	   					
			 	   					if (data.success) {
			 	   						App.showMessage('Saved location for selected node.');
			 	   					}
			 	   				}
		 	       			});
                   		}
                   	}
                    ,{
                    	text: 'Close'
            			,handler: function() {
	    					Ext.getCmp('nodes-services-location-window').close();
                		}
                	}
            	]
            });
		 
		 	win.show(this);
		 	var map = win.items.get(0).getMap();
		 	
		 	google.maps.event.addListener(map, 'click', function(event) {
		 		if (marker) {
		 			marker.setMap(null);
		 		}
		 		
		 		Ext.getCmp('nodes-services-location-window').buttons[0].show();
		 		
		 		var location = event.latLng;
				marker = new google.maps.Marker({
					position: location, 
					map: map
				});

				map.setCenter(location);
		 	});
		 	
			Ext.Ajax.request({
   				url: '/dixi/nodes/location'
				,params: { node: node.data.address }
   				,success: function(data) { 
   					var data = Ext.util.JSON.decode(data.responseText);
   					
   					if (data.success) {
   				 		var location = new google.maps.LatLng(data.data.lat, data.data.lng);
   						marker = new google.maps.Marker({
   							position: location, 
   							map: map
   						});
   						
   						map.setCenter(location);
   						map.setZoom(6);
   					}
   				}
   			});
		}
	});
	
	// filter nodes grid by selected services
	App.Dixi.Nodes.on('nodes-filter-add', function() {
		var window = Ext.getCmp('dixi-nodes-filter-window');
		var form = window.items.get(0).getForm();
		
		if (form.isValid()) {	         
			var store = App.Dixi.Nodes.getGrid().store;
			store.baseParams = { action: 'filter', services: form.getValues().services };
			store.load();
		}

		window.close();
	});
	
	// start selected services
	App.Dixi.Nodes.on('nodes-services-start', function(grid) {
		var services = grid.getSelectionModel().getSelections();
		var node = App.Dixi.Nodes.getActiveTab().title;
		
		if (node && services.length) {
			var data = new Array();
			
			for (service in services) {
				var value = services[service].data;
				if (value) data.push(value.value);
			}
			
            var win = new Ext.Window({
            	id: 'nodes-services-start-window'
        		,title: 'Start services'
				,frame: true
				,modal: true
				,border: false	
                ,width: 320
                ,items: [
					new Ext.FormPanel({
						id: 'nodes-services-start-window-form'
						,frame: true
						,border: false							
						,labelWidth: 75
						,labelAlign: 'right'
					    ,bodyStyle:'padding:5px'
				    	,defaults: { width: 200 }
					    ,items: [
							new Ext.ux.form.SpinnerField({
								fieldLabel: 'Threads'
							    ,name: 'threads'
				            	,minValue: 1
				            	,maxValue: 10
				            	,value: 1
							})
					    ]
					})
                ]
                ,buttons: [
                    {
                    	text: 'Start'
            			,handler: function() {
	    					var window = Ext.getCmp('nodes-services-start-window');
	    					var form = Ext.getCmp('nodes-services-start-window-form').getForm()
	    					
	    					if (form.isValid()) {
		            			Ext.Ajax.request({
		            				url: '/dixi/services/start'
		            				,params: { node: node, services: data.toString(), threads: form.getValues().threads }
		            				,success: function(data) {
		            					var data = Ext.util.JSON.decode(data.responseText);
		            					window.close();
		            					
		            					if (data.success) {
		            						App.showMessage('Selected services started.');
		            					}
		            				}
		            				,failure: function() {
		            					window.close();
		            				}
		            			});
	    					}
                		}
                	}
            	]
            });
            
            win.show(this);
		}
	});

	// stop selected services
	App.Dixi.Nodes.on('nodes-services-stop', function(grid) {
		var services = grid.getSelectionModel().getSelections();
		var node = App.Dixi.Nodes.getActiveTab().title;
		
		if (services.length) {
			var data = new Array();
			
			for (service in services) {
				var value = services[service].data;
				if (value) data.push(value.value);
			}
			
			Ext.Ajax.request({
				url: '/dixi/services/stop'
				,params: { node: node, services: data.toString() }
				,success: function(data) { 
					var data = Ext.util.JSON.decode(data.responseText);
					
					if (data.success) {
						App.showMessage('Selected services stopped.');
					}
				}
			});
		}
	});
	
	// restart selected services
	App.Dixi.Nodes.on('nodes-services-restart', function(grid) {
		var services = grid.getSelectionModel().getSelections();
		var node = App.Dixi.Nodes.getActiveTab().title;
		
		if (services.length) {
			var data = new Array();
			
			for (service in services) {
				var value = services[service].data;
				if (value) data.push(value.value);
			}
			
			Ext.Ajax.request({
				url: '/dixi/services/restart'
				,params: { node: node, services: data.toString() }
				,success: function(data) { 
					var data = Ext.util.JSON.decode(data.responseText);
					
					if (data.success) {
						App.showMessage('Selected services restart.');
					}
				}
			});
		}
	});
});
