Ext.namespace('App');

App = function(){
    var msgCt;

    function createMessageBox(text)
    {
        return ['<div class="msg" id="msg">',
            '<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>',
            '<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc">', text, '</div></div></div>',
            '<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>',
            '</div>'].join('');
    };

    return {
        showMessage: function(text, sec) {
            if (!msgCt) {
                msgCt = Ext.DomHelper.insertFirst(document.body, {id:'msg-div'}, true);
            }

            var m = Ext.DomHelper.append(msgCt, {html: createMessageBox(text)}, true);
            var yoffset = document.getElementById("msg").style.height;

            msgCt.alignTo(document, 'br-br', [-10, yoffset - 10]);

            if (!sec) sec = 3;
            m.slideIn('b').pause(sec).ghost('b', {remove:true});
        }
    	,isEmpty: function (obj) {
	        for (var prop in obj) {
	            if(obj.hasOwnProperty(prop))
	                return false;
	        }
	
	        return true;
	    }
    	,getFormFieldStoreData: function(formPanel, fieldName) 
    	{
    		var values = formPanel.getForm().getValues();
    	    var store = formPanel.find('name', fieldName)[0].getStore();
    	    var id = store.findExact('name', values[fieldName]);
    	    
    	    if (store) {
    	        return store.getAt(id).data;
    	    }

    	    return null;
    	}
    };
}();