Ext.onReady(function() {
	var login_form = new Ext.FormPanel( {
		id: 'login-form',
		method: 'POST',
		url: '/login.json',
		frame: true,
		border: false,
		buttonAlign: 'center',
		defaultType: 'textfield',
		labelWidth: 100,
		bodyStyle: 'padding:10px 10px 15px 15px;',
		items: [ {
			fieldLabel: 'Username',
			name: 'username',
			id: 'login-username',
			allowBlank: false
		}, {
			inputType: 'password',
			fieldLabel: 'Password',
			name: 'password',
			id: 'login-password',
			allowBlank: false
		} ],
		buttons: [ {
			text: 'Login',
			formBind: true,
			handler: function() {
				login_form.getForm().login();
			}
		} ],
		keys: [ {
			key: [ Ext.EventObject.ENTER ],
			handler: function() {
				login_form.getForm().login();
			}
		} ],
		login: function() {
			this.on( {
				beforeaction: function() {
					Ext.getCmp('login-panel-statusbar').showBusy();
				}
			});
			
			this.submit( {
				success: function(f, a) {
					Ext.getCmp('login-panel-statusbar').setStatus( {
						text: 'Login successful!',
						iconCls: 'x-status-valid'
					});
					setTimeout(function() {
						window.location = '/';
					}, 500);
				},
				failure: function(f, a) {
					var msg;
					
					if (a.failureType == 'server') {
						msg = a.result.errors;
						Ext.getCmp('login-username').focus();
					} else {
						if (typeof (a.response) == 'undefined') {
							msg = 'Field cannot be empty !'
						} else {
							msg = 'Cannot connect to server!';
						}
					}
					
					Ext.getCmp('login-panel-statusbar').setStatus( {
						text: msg,
						iconCls: 'x-status-error'
					});
				}
			});
		}
	});
	
	var login_panel = new Ext.Panel( {
		title: 'Login',
		layout: 'fit',
		width: 310,
		height: 170,
		resizable: false,
		closable: false,
		draggable: false,
		renderTo: 'login',
		items: [ login_form ],
		id: 'login-panel',
		bbar: new Ext.ux.StatusBar( {
			text: 'Ready',
			id: 'login-panel-statusbar',
			iconCls: 'x-status-saved'
		})
	});
});
