var subscriptionUnsubscribe = function(b, e) {
	var s = subscriptionGrid.getSelectionModel().getSelected();
    if(s != null)
    {
    	Ext.MessageBox.confirm('Unsubscribe', 'Do you really want to unsubscribe?', function(btn){
    		if(btn == 'yes'){
    			new Ext.data.Connection().request({
    			    url: '/monitoring/subscriptions/unsubscribe',
    			    method: 'POST',
    			    params: {'id': s.data.id},
    			    success: function(responseObject) {
    			    	subscriptionGrid.store.reload();
    			    },
    			    failure: function() {
    			        Ext.Msg.alert('Status', 'Unsubscription failed.');
    			    }
    			});
    		}
    	});	
    }
}

var subscriptionStore = new Ext.data.JsonStore({
	successProperty: 'success',
	root: 'data',
	idProperty: 'invalid',
//	autoLoad: true,
	fields: [
		{name: 'id'},
		{name: 'rule', allowBlank: false},
	],
	proxy: new Ext.data.HttpProxy({
		url: '/monitoring/subscriptions.json'
	}),
	sortInfo: {
		field: 'id',
		direction: 'DESC'
	},
	listeners: {
		load: function(s, rs, o){
			s.sort(s.sortInfo.field, s.sortInfo.direction);
		}
	}
});

var subscriptionGrid = new Ext.grid.GridPanel({
	iconCls: 'x-icon-subscriptions',
	frame: true,
	title: 'Subscriptions',
	autoScroll: true,
	store: subscriptionStore,
	enableHdMenu: false,
	columns: [
		{header: 'ID', width: 120, sortable: false, dataIndex: 'id'},
		{header: 'Rule', width: 70, sortable: false, dataIndex: 'rule'}
	],
	tbar: [{
		text: 'Refresh',
		iconCls: 'silk-table-refresh',
		handler: function(b, e) {
			subscriptionGrid.store.reload();
		}
	}, {
		text: 'Unsubscribe',
		iconCls: 'silk-cross',
		handler: subscriptionUnsubscribe
	}],
	viewConfig: {
		forceFit: true
	}
});