var FUNCTIONS = [
  ['equal',		  		     'urn:oasis:names:tc:xacml:1.0:function:{0}-equal']
  ,['greater-than', 		 'urn:oasis:names:tc:xacml:1.0:function:{0}-greater-than']
  ,['greater-than-or-equal', 'urn:oasis:names:tc:xacml:1.0:function:{0}-greater-than-or-equal']
  ,['less-than', 			 'urn:oasis:names:tc:xacml:1.0:function:{0}-less-than']
  ,['less-than-or-equal',    'urn:oasis:names:tc:xacml:1.0:function:{0}-less-than-or-equal']
  ,['match', 				 'urn:oasis:names:tc:xacml:1.0:function:{0}-match']
];

Ext.onReady(function() {
	App.Vops.Policies = new App.Vops.Panel();

	// click on tree node and generate form
	App.Vops.Policies.getComponent('vops-tree').on('click', function(node, e) {
		var XML_POLICY_EDITABLE_OBJECT = new Array('Match', 'AttributeValue', 'AttributeDesignator');
	    var form = App.Vops.Policies.getComponent('vops-form');
	    var nodeName = node.attributes.tagName;
	    var isObject = false;

	    Ext.each(XML_POLICY_EDITABLE_OBJECT, function(a) {
	    	if (nodeName.indexOf(a) >= 0) { 
	    		isObject = true;
	    	}
	    });

	    form.removeAll(true);
	    form.clear();

	    if (isObject) {
	    	if (nodeName.indexOf('Match') >= 0) {
	    		var matchTempId;
	    		var matchId = '';
	    		
	    		matchTempId = node.attributes.MatchId;
	    		matchTempId = matchTempId.substr(38, matchTempId.length).split('-');

	    		for (var i=1; i < matchTempId.length; i++) matchId += '-' + matchTempId[i];
	    		matchId = 'urn:oasis:names:tc:xacml:1.0:function:{0}' + matchId;
	    		
			    form.add(
		    		{
	                    xtype: 'combo'
	                    ,id: 'attributeBox'
	                    ,mode: 'local'
	                	,triggerAction: 'all'
	                    ,allowBlank: false
	                    ,editable: false
	                    ,name: 'attribute'
	                    ,fieldLabel: 'Attribute'
	                	,displayField: 'name'
	            		,valueField: 'value'
	                    ,store: new Ext.data.JsonStore({
	                        autoLoad: true
	                        ,fields: ['name', 'value']
	                     	,proxy: new Ext.data.HttpProxy({ url: '/vops/policies/constants/' + node.parentNode.attributes.tagName })
		                    ,listeners: {
                            	load: {
	                    			fn: function() {
	                    				Ext.getCmp('attributeBox').setValue(
                    						node.lastChild.attributes.AttributeId + '|' + 
                    						node.lastChild.attributes.DataType
                						);
                                    }
	                            }
		                    }
	                    })
			    	}
		    		,{
	                    xtype: 'combo'
	                    ,mode: 'local'
	                	,triggerAction: 'all'
	                    ,lastQuery: ''
	                    ,allowBlank:false
	                    ,editable: false
	                    ,name: 'operation'
	                    ,fieldLabel: 'Function'
	                	,displayField: 'name'
	            		,valueField: 'value'
            			,value: matchId
	            		,store: new Ext.data.ArrayStore({
	            	        id: 0,
	            	        fields: ['name', 'value'],
	            	        data: FUNCTIONS
	            	    })
		    		}
		    		,{
		    			fieldLabel: 'Value'
	    				,name: 'Value'
    					,xtype: 'textarea'
						,allowBlank: false
						,value : node.firstChild.attributes.innerText
		    		}
	    		);
	    	} 
	    }
	    else {
		    Ext.each(node.attributes, function(a) {
		    	Ext.each(XML_POLICY_ATTIBUTES, function(b) {
		    		var attribute = a[b];
		    		if (attribute) {
		    		    form.add({
		    		        fieldLabel: b
		    		        ,value : attribute
		    		        ,name: b
		    		    });
		    		}
				});
		    });
		    
	    	if (node.attributes.innerText) {
			    form.add({
			        fieldLabel: 'Text'
		        	,name: 'innerText'
			        ,value : node.attributes.innerText
			        ,xtype: 'textarea'
			    });
	    	}
	    }
	    
	    form.doLayout();
	    
	    if (form.items.length) {
	    	form.enable();
	    }
	    else {
	    	form.removeAll(true);
	    	form.disable();
	    }
	});
	
	// added new rule from template
	App.Vops.Policies.on('tree-add-rule-template', function() {
		var window = Ext.getCmp('vops-rule-template-window'); 
		var form = window.getComponent('vops-rule-template-window-form').getForm();
				
		if (form.isValid()) {
			var values = form.getFieldValues();
			var tree = App.Vops.Policies.getComponent('vops-tree');

			App.Vops.Policies.getComponent('vops-tree').getLoader().loadFromXml(values.template, tree.getRootNode().firstChild);
			window.close();
			
			App.showMessage('Added new rule from template.');
		}
	});
	
	// reload data
	App.Vops.Policies.on('tree-reload', function() {
		var tree = App.Vops.Policies.getComponent('vops-tree');
		var form = App.Vops.Policies.getComponent('vops-form');
		
		tree.getLoader().load(tree.getRootNode());
		form.removeAll(true);
		form.disable();
		
		App.showMessage('Policy reloaded.');
	});
	
	// add new node
	App.Vops.Policies.on('tree-add', function() {
		var tree = App.Vops.Policies.getComponent('vops-tree');
		var node = tree.getSelectionModel().getSelectedNode();
		var nodeName = node.attributes.tagName.slice(0, -1);

        var win = new Ext.Window({
        	id: 'vops-tree-node-add-window'
    		,title: 'Add new element'
			,frame: true
			,modal: true
			,border: false	
            ,width: 520
            ,items: [
				new Ext.FormPanel({
					id: 'vops-tree-node-add-window-form'
					,frame: true
					,border: false							
					,labelWidth: 75
					,labelAlign: 'right'
				    ,bodyStyle:'padding:5px'
			    	,defaults: { width: 380 }
				    ,defaultType: 'textfield'
				    ,items: [
		             	{
                            xtype: 'combo'
                            ,mode: 'local'
                        	,triggerAction: 'all'
                            ,allowBlank: false
                            ,editable: false
                            ,name: 'attribute'
                            ,fieldLabel: 'Attribute'
                        	,displayField: 'name'
                    		,valueField: 'value'
                            ,store: new Ext.data.JsonStore({
                                autoLoad: true
                                ,fields: ['name', 'value']
                             	,proxy: new Ext.data.HttpProxy({ url: '/vops/policies/constants/' + nodeName })
                            })
                        }
		             	,{
                            xtype: 'combo'
                            ,mode: 'local'
                        	,triggerAction: 'all'
                            ,lastQuery: ''
                            ,allowBlank:false
                            ,editable: false
                            ,name: 'operation'
                            ,fieldLabel: 'Function'
                        	,displayField: 'name'
                    		,valueField: 'value'
                    		,store: new Ext.data.ArrayStore({
                    	        id: 0,
                    	        fields: ['name', 'value'],
                    	        data: FUNCTIONS
                    	    }),
                        }
		             	,{
                        	name: 'value'
                        	,fieldLabel: 'Value'
                    		,allowBlank: false
                        }
				    ]
				})
             ]
            ,buttons: [
                {
                	text: 'Create'
        			,handler: function() {
	            		var window = Ext.getCmp('vops-tree-node-add-window'); 
	            		var formPanel = window.getComponent('vops-tree-node-add-window-form');
	            		var form = formPanel.getForm();
	            		
	            		if (form.isValid()) {
		            		var values = formPanel.getForm().getValues();
		            		var data = {}
		            		
		            		data.attribute = App.getFormFieldStoreData(formPanel, 'attribute');
		            		data.attribute.value = data.attribute.value.split('|')[1];
		            		data.operation = App.getFormFieldStoreData(formPanel, 'operation');
		            		data.operation = String.format(data.operation.value, data.attribute.value.split('#')[1]);
		            		data.value = values['value'];
		            		
		                    var template = String.format(
	                    		'<Template>' +
	                    			'<' + nodeName + 'Match MatchId="{0}">' +
	                    				'<AttributeValue DataType="{1}">{2}</AttributeValue>' +
	                    				'<' + nodeName + 'AttributeDesignator AttributeId="{3}" DataType="{4}"/>' +
                    				'</' + nodeName + 'Match>' +
		                    	'</Template>'
	                    	    ,data.operation
	                    	    ,data.attribute.value
	                    	    ,data.value
	                    	    ,data.attribute.name
	                    	    ,data.attribute.value
	                        );
		            		
		                    // insert Any* if there is no child nodes
        	        		var any = 'Any';
		                    
        	        		if (node.firstChild.attributes.tagName.slice(0, any.length) == any) {
        	        			node.firstChild.remove(true);
		                    	node.appendChild(new Ext.tree.TreeNode({
		                            text: nodeName
		                            ,tagName: nodeName
		                            ,iconCls: 'policy-tree-list'
		                            ,allowDrag: false
		                        }));
		                    }
		                    
		            		App.Vops.Policies.getComponent('vops-tree').getLoader().loadFromXml(template, node.firstChild);
		            		App.showMessage(String.format('Added new {0} to current Rule.', nodeName));
		        			window.close();
	            		}
            		}
            	}
            	,{
            		text: 'Close'
        			,handler: function() {
            			Ext.getCmp('vops-tree-node-add-window').close();
            		}
            	}
        	]
        });
        
        win.show(this);
	});
	
	// delete selected node
	App.Vops.Policies.on('tree-delete', function(item) {
        var node = item.parentMenu.contextNode;
        var isRemoved = false;
        
        var parent = node.parentNode;
        var main = parent.parentNode;
        
        if (parent)  {
        	node.remove(true);
        	isRemoved = true;
        }
        
        // insert Any* if there is no child nodes
        if (!parent.hasChildNodes()) {
        	main.appendChild(new Ext.tree.TreeNode({
                text: 'Any' + parent.attributes.tagName
                ,tagName: 'Any' + parent.attributes.tagName
                ,iconCls: 'policy-tree-list'
                ,allowDrag: false
            }));
        	
        	parent.remove(true);
        	isRemoved = true;
        }
        
        if (isRemoved) {
        	var form = App.Vops.Policies.getComponent('vops-form');
        	form.removeAll(true);
        	form.disable();
        }
	});
	
	// publish tree data to server
	App.Vops.Policies.on('tree-publish', function() {
		App.Vops.Policies.getComponent('vops-tree').save();

		var form = App.Vops.Policies.getComponent('vops-form');
		form.removeAll(true);
		form.disable();
		
		App.showMessage('Published policy to server.');
	});
	
	// form save data
	App.Vops.Policies.on('form-save', function() {
		var selectedNode = App.Vops.Policies.getComponent('vops-tree').getSelectionModel().getSelectedNode();
		var formPanel = App.Vops.Policies.getComponent('vops-form');
		var items = formPanel.items
		
		if (selectedNode.attributes.tagName.indexOf('Match') >= 0) {
			if (formPanel.getForm().isValid()) {
				var temp, value;
				var attributeId, dataType, matchId;
				
				temp = items.get(0).getValue();
				value = items.get(2).getValue();
				
				attributeId = temp.split('|')[0];
				dataType = temp.split('|')[1];
				matchId = String.format(items.get(1).getValue(), dataType.split('#')[1]); 
				
				selectedNode.attributes.MatchId = matchId;
				selectedNode.firstChild.attributes.DataType = dataType;
				selectedNode.firstChild.attributes.innerText = value;
				selectedNode.firstChild.attributes.text = value;
				selectedNode.lastChild.attributes.AttributeId = attributeId;
				selectedNode.lastChild.attributes.DataType = dataType;
			}
		}
		else {
			for (var i=0; item = items.get(i); i++) {
				if (selectedNode) {
					selectedNode.attributes[item.getName()] = item.getValue(); 
				}
			}
		}
		
		if (formPanel.getForm().isValid()) {
			App.showMessage('Saved changes.');
		}
	});
	
	// form cancel editing
	App.Vops.Policies.on('form-cancel', function() {
		App.Vops.Policies.getComponent('vops-tree').getSelectionModel().clearSelections();
			
		var form = App.Vops.Policies.getComponent('vops-form');
		form.removeAll(true);
		form.disable();
	});
});
