/**
 * Copyright (c) 2009 - 2010 Chris Leonello
 * jqPlot is currently available for use in all personal or commercial projects 
 * under both the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL 
 * version 2.0 (http://www.gnu.org/licenses/gpl-2.0.html) licenses. This means that you can 
 * choose the license that best suits your project and use it accordingly. 
 *
 * Although not required, the author would appreciate an email letting him 
 * know of any substantial use of jqPlot.  You can reach the author at: 
 * chris dot leonello at gmail dot com or see http://www.jqplot.com/info.php .
 *
 * If you are feeling kind and generous, consider supporting the project by
 * making a donation at: http://www.jqplot.com/donate.php .
 *
 * jqPlot includes date instance methods and printf/sprintf functions by other authors:
 *
 * Date instance methods contained in jqplot.dateMethods.js:
 *
 *     author Ken Snyder (ken d snyder at gmail dot com)
 *     date 2008-09-10
 *     version 2.0.2 (http://kendsnyder.com/sandbox/date/)     
 *     license Creative Commons Attribution License 3.0 (http://creativecommons.org/licenses/by/3.0/)
 *
 * JavaScript printf/sprintf functions contained in jqplot.sprintf.js:
 *
 *     version 2007.04.27
 *     author Ash Searle
 *     http://hexmen.com/blog/2007/03/printf-sprintf/
 *     http://hexmen.com/js/sprintf.js
 *     The author (Ash Searle) has placed this code in the public domain:
 *     "This code is unrestricted: you are free to use it however you like."
 * 
 */
(function(e){e.jqplot.DonutRenderer=function(){e.jqplot.LineRenderer.call(this)};e.jqplot.DonutRenderer.prototype=new e.jqplot.LineRenderer();e.jqplot.DonutRenderer.prototype.constructor=e.jqplot.DonutRenderer;e.jqplot.DonutRenderer.prototype.init=function(p,t){this.diameter=null;this.innerDiameter=null;this.thickness=null;this.padding=20;this.sliceMargin=0;this.ringMargin=null;this.fill=true;this.shadowOffset=2;this.shadowAlpha=0.07;this.shadowDepth=5;this.highlightMouseOver=true;this.highlightMouseDown=false;this.highlightColors=[];this.startAngle=0;this.tickRenderer=e.jqplot.DonutTickRenderer;if(p.highlightMouseDown&&p.highlightMouseOver==null){p.highlightMouseOver=false}e.extend(true,this,p);if(this.diameter!=null){this.diameter=this.diameter-this.sliceMargin}this._diameter=null;this._innerDiameter=null;this._radius=null;this._innerRadius=null;this._thickness=null;this._previousSeries=[];this._numberSeries=1;this._sliceAngles=[];this._highlightedPoint=null;if(this.highlightColors.length==0){for(var r=0;r<this.seriesColors.length;r++){var q=e.jqplot.getColorComponents(this.seriesColors[r]);var n=[q[0],q[1],q[2]];var s=n[0]+n[1]+n[2];for(var o=0;o<3;o++){n[o]=(s>570)?n[o]*0.8:n[o]+0.3*(255-n[o]);n[o]=parseInt(n[o],10)}this.highlightColors.push("rgb("+n[0]+","+n[1]+","+n[2]+")")}}t.postParseOptionsHooks.addOnce(l);t.postInitHooks.addOnce(g);t.eventListenerHooks.addOnce("jqplotMouseMove",b);t.eventListenerHooks.addOnce("jqplotMouseDown",a);t.eventListenerHooks.addOnce("jqplotMouseUp",j);t.eventListenerHooks.addOnce("jqplotClick",f);t.eventListenerHooks.addOnce("jqplotRightClick",m);t.postDrawHooks.addOnce(h)};e.jqplot.DonutRenderer.prototype.setGridData=function(r){var o=[];var s=[];var n=this.startAngle/180*Math.PI;for(var q=0;q<this.data.length;q++){o.push(this.data[q][1]);s.push([this.data[q][0]]);if(q>0){o[q]+=o[q-1]}}var p=Math.PI*2/o[o.length-1];for(var q=0;q<o.length;q++){s[q][1]=o[q]*p}this.gridData=s};e.jqplot.DonutRenderer.prototype.makeGridData=function(r,s){var o=[];var t=[];var n=this.startAngle/180*Math.PI;for(var q=0;q<r.length;q++){o.push(r[q][1]);t.push([r[q][0]]);if(q>0){o[q]+=o[q-1]}}var p=Math.PI*2/o[o.length-1];for(var q=0;q<o.length;q++){t[q][1]=o[q]*p}return t};e.jqplot.DonutRenderer.prototype.drawSlice=function(x,u,t,p,s){var n=this._diameter/2;var v=n-this._thickness;var w=this.fill;x.save();x.translate(this._center[0],this._center[1]);if(s){for(var q=0;q<this.shadowDepth;q++){x.save();x.translate(this.shadowOffset*Math.cos(this.shadowAngle/180*Math.PI),this.shadowOffset*Math.sin(this.shadowAngle/180*Math.PI));o()}}else{o()}function o(){if(t>6.282+this.startAngle){t=6.282+this.startAngle;if(u>t){u=6.281+this.startAngle}}if(u==t){return}x.beginPath();x.fillStyle=p;x.strokeStyle=p;x.arc(0,0,n,u,t,false);x.lineTo(v*Math.cos(t),v*Math.sin(t));x.arc(0,0,v,t,u,true);x.closePath();if(w){x.fill()}else{x.stroke()}}if(s){for(var q=0;q<this.shadowDepth;q++){x.restore()}}x.restore()};e.jqplot.DonutRenderer.prototype.draw=function(F,K,s){var H;var B=(s!=undefined)?s:{};var p=0;var o=0;var t=1;if(s.legendInfo&&s.legendInfo.placement=="inside"){var A=s.legendInfo;switch(A.location){case"nw":p=A.width+A.xoffset;break;case"w":p=A.width+A.xoffset;break;case"sw":p=A.width+A.xoffset;break;case"ne":p=A.width+A.xoffset;t=-1;break;case"e":p=A.width+A.xoffset;t=-1;break;case"se":p=A.width+A.xoffset;t=-1;break;case"n":o=A.height+A.yoffset;break;case"s":o=A.height+A.yoffset;t=-1;break;default:break}}var x=(B.shadow!=undefined)?B.shadow:this.shadow;var L=(B.showLine!=undefined)?B.showLine:this.showLine;var G=(B.fill!=undefined)?B.fill:this.fill;var q=F.canvas.width;var z=F.canvas.height;var y=q-p-2*this.padding;var I=z-o-2*this.padding;var u=Math.min(y,I);var J=u;var M=(this.ringMargin==null)?this.sliceMargin*2:this.ringMargin;for(var H=0;H<this._previousSeries.length;H++){J-=2*this._previousSeries[H]._thickness+2*M}this._diameter=this.diameter||J;if(this.innerDiameter!=null){var E=(this._numberSeries>1&&this.index>0)?this._previousSeries[0]._diameter:this._diameter;this._thickness=this.thickness||(E-this.innerDiameter-2*M*this._numberSeries)/this._numberSeries/2}else{this._thickness=this.thickness||u/2/(this._numberSeries+1)*0.85}var C=this._radius=this._diameter/2;this._innerRadius=this._radius-this._thickness;var n=this.startAngle/180*Math.PI;this._center=[(q-t*p)/2+t*p,(z-t*o)/2+t*o];if(this.shadow){var D="rgba(0,0,0,"+this.shadowAlpha+")";for(var H=0;H<K.length;H++){var v=(H==0)?n:K[H-1][1]+n;v+=this.sliceMargin/180*Math.PI;this.renderer.drawSlice.call(this,F,v,K[H][1]+n,D,true)}}for(var H=0;H<K.length;H++){var v=(H==0)?n:K[H-1][1]+n;v+=this.sliceMargin/180*Math.PI;this._sliceAngles.push([v,K[H][1]+n]);this.renderer.drawSlice.call(this,F,v,K[H][1]+n,this.seriesColors[H])}};e.jqplot.DonutAxisRenderer=function(){e.jqplot.LinearAxisRenderer.call(this)};e.jqplot.DonutAxisRenderer.prototype=new e.jqplot.LinearAxisRenderer();e.jqplot.DonutAxisRenderer.prototype.constructor=e.jqplot.DonutAxisRenderer;e.jqplot.DonutAxisRenderer.prototype.init=function(n){this.tickRenderer=e.jqplot.DonutTickRenderer;e.extend(true,this,n);this._dataBounds={min:0,max:100};this.min=0;this.max=100;this.showTicks=false;this.ticks=[];this.showMark=false;this.show=false};e.jqplot.DonutLegendRenderer=function(){};e.jqplot.DonutLegendRenderer.prototype.init=function(n){this.numberRows=null;this.numberColumns=null;e.extend(true,this,n)};e.jqplot.DonutLegendRenderer.prototype.draw=function(){var q=this;if(this.show){var y=this._series;var B="position:absolute;";B+=(this.background)?"background:"+this.background+";":"";B+=(this.border)?"border:"+this.border+";":"";B+=(this.fontSize)?"font-size:"+this.fontSize+";":"";B+=(this.fontFamily)?"font-family:"+this.fontFamily+";":"";B+=(this.textColor)?"color:"+this.textColor+";":"";this._elem=e('<table class="jqplot-table-legend" style="'+B+'"></table>');var F=false,x=false,n,v;var z=y[0];var o=new e.jqplot.ColorGenerator(z.seriesColors);if(z.show){var G=z.data;if(this.numberRows){n=this.numberRows;if(!this.numberColumns){v=Math.ceil(G.length/n)}else{v=this.numberColumns}}else{if(this.numberColumns){v=this.numberColumns;n=Math.ceil(G.length/this.numberColumns)}else{n=G.length;v=1}}var E,D,p,t,r,u,w,C;var A=0;for(E=0;E<n;E++){if(x){p=e('<tr class="jqplot-table-legend"></tr>').prependTo(this._elem)}else{p=e('<tr class="jqplot-table-legend"></tr>').appendTo(this._elem)}for(D=0;D<v;D++){if(A<G.length){u=this.labels[A]||G[A][0].toString();C=o.next();if(!x){if(E>0){F=true}else{F=false}}else{if(E==n-1){F=false}else{F=true}}w=(F)?this.rowSpacing:"0";t=e('<td class="jqplot-table-legend" style="text-align:center;padding-top:'+w+';"><div><div class="jqplot-table-legend-swatch" style="border-color:'+C+';"></div></div></td>');r=e('<td class="jqplot-table-legend" style="padding-top:'+w+';"></td>');if(this.escapeHtml){r.text(u)}else{r.html(u)}if(x){r.prependTo(p);t.prependTo(p)}else{t.appendTo(p);r.appendTo(p)}F=true}A++}}}}return this._elem};e.jqplot.DonutLegendRenderer.prototype.pack=function(q){if(this.show){var p={_top:q.top,_left:q.left,_right:q.right,_bottom:this._plotDimensions.height-q.bottom};if(this.placement=="inside"){switch(this.location){case"nw":var o=p._left+this.xoffset;var n=p._top+this.yoffset;this._elem.css("left",o);this._elem.css("top",n);break;case"n":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=p._top+this.yoffset;this._elem.css("left",o);this._elem.css("top",n);break;case"ne":var o=q.right+this.xoffset;var n=p._top+this.yoffset;this._elem.css({right:o,top:n});break;case"e":var o=q.right+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({right:o,top:n});break;case"se":var o=q.right+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({right:o,bottom:n});break;case"s":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"sw":var o=p._left+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"w":var o=p._left+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({left:o,top:n});break;default:var o=p._right-this.xoffset;var n=p._bottom+this.yoffset;this._elem.css({right:o,bottom:n});break}}else{switch(this.location){case"nw":var o=this._plotDimensions.width-p._left+this.xoffset;var n=p._top+this.yoffset;this._elem.css("right",o);this._elem.css("top",n);break;case"n":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=this._plotDimensions.height-p._top+this.yoffset;this._elem.css("left",o);this._elem.css("bottom",n);break;case"ne":var o=this._plotDimensions.width-q.right+this.xoffset;var n=p._top+this.yoffset;this._elem.css({left:o,top:n});break;case"e":var o=this._plotDimensions.width-q.right+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({left:o,top:n});break;case"se":var o=this._plotDimensions.width-q.right+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"s":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=this._plotDimensions.height-q.bottom+this.yoffset;this._elem.css({left:o,top:n});break;case"sw":var o=this._plotDimensions.width-p._left+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({right:o,bottom:n});break;case"w":var o=this._plotDimensions.width-p._left+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({right:o,top:n});break;default:var o=p._right-this.xoffset;var n=p._bottom+this.yoffset;this._elem.css({right:o,bottom:n});break}}}};function c(r,q,o){o=o||{};o.axesDefaults=o.axesDefaults||{};o.legend=o.legend||{};o.seriesDefaults=o.seriesDefaults||{};var n=false;if(o.seriesDefaults.renderer==e.jqplot.DonutRenderer){n=true}else{if(o.series){for(var p=0;p<o.series.length;p++){if(o.series[p].renderer==e.jqplot.DonutRenderer){n=true}}}}if(n){o.axesDefaults.renderer=e.jqplot.DonutAxisRenderer;o.legend.renderer=e.jqplot.DonutLegendRenderer;o.legend.preDraw=true}}function g(r,q,o){for(var p=1;p<this.series.length;p++){if(!this.series[p]._previousSeries.length){for(var n=0;n<p;n++){if(this.series[p].renderer.constructor==e.jqplot.DonutRenderer&&this.series[n].renderer.constructor==e.jqplot.DonutRenderer){this.series[p]._previousSeries.push(this.series[n])}}}}for(p=0;p<this.series.length;p++){if(this.series[p].renderer.constructor==e.jqplot.DonutRenderer){this.series[p]._numberSeries=this.series.length;if(this.series[p].highlightMouseOver){this.series[p].highlightMouseDown=false}}}this.target.bind("mouseout",{plot:this},function(s){i(s.data.plot)})}var k=false;function l(n){for(var o=0;o<this.series.length;o++){this.series[o].seriesColors=this.seriesColors;this.series[o].colorGenerator=this.colorGenerator}}function d(r,q,p){var o=r.series[q];var n=r.plugins.donutRenderer.highlightCanvas;n._ctx.clearRect(0,0,n._ctx.canvas.width,n._ctx.canvas.height);o._highlightedPoint=p;r.plugins.donutRenderer.highlightedSeriesIndex=q;o.renderer.drawSlice.call(o,n._ctx,o._sliceAngles[p][0],o._sliceAngles[p][1],o.highlightColors[p],false)}function i(p){var n=p.plugins.donutRenderer.highlightCanvas;n._ctx.clearRect(0,0,n._ctx.canvas.width,n._ctx.canvas.height);for(var o=0;o<p.series.length;o++){p.series[o]._highlightedPoint=null}p.plugins.donutRenderer.highlightedSeriesIndex=null;p.target.trigger("jqplotDataUnhighlight")}function b(r,q,u,t,s){if(t){var p=[t.seriesIndex,t.pointIndex,t.data];var o=jQuery.Event("jqplotDataMouseOver");o.pageX=r.pageX;o.pageY=r.pageY;s.target.trigger(o,p);if(s.series[p[0]].highlightMouseOver&&!(p[0]==s.plugins.donutRenderer.highlightedSeriesIndex&&p[1]==s.series[p[0]]._highlightedPoint)){var n=jQuery.Event("jqplotDataHighlight");n.pageX=r.pageX;n.pageY=r.pageY;s.target.trigger(n,p);d(s,p[0],p[1])}}else{if(t==null){i(s)}}}function a(q,p,t,s,r){if(s){var o=[s.seriesIndex,s.pointIndex,s.data];if(r.series[o[0]].highlightMouseDown&&!(o[0]==r.plugins.donutRenderer.highlightedSeriesIndex&&o[1]==r.series[o[0]]._highlightedPoint)){var n=jQuery.Event("jqplotDataHighlight");n.pageX=q.pageX;n.pageY=q.pageY;r.target.trigger(n,o);d(r,o[0],o[1])}}else{if(s==null){i(r)}}}function j(p,o,s,r,q){var n=q.plugins.donutRenderer.highlightedSeriesIndex;if(n!=null&&q.series[n].highlightMouseDown){i(q)}}function f(q,p,t,s,r){if(s){var o=[s.seriesIndex,s.pointIndex,s.data];var n=jQuery.Event("jqplotDataClick");n.pageX=q.pageX;n.pageY=q.pageY;r.target.trigger(n,o)}}function m(r,q,u,t,s){if(t){var p=[t.seriesIndex,t.pointIndex,t.data];var n=s.plugins.donutRenderer.highlightedSeriesIndex;if(n!=null&&s.series[n].highlightMouseDown){i(s)}var o=jQuery.Event("jqplotDataRightClick");o.pageX=r.pageX;o.pageY=r.pageY;s.target.trigger(o,p)}}function h(){this.plugins.donutRenderer={highlightedSeriesIndex:null};this.plugins.donutRenderer.highlightCanvas=new e.jqplot.GenericCanvas();this.eventCanvas._elem.before(this.plugins.donutRenderer.highlightCanvas.createElement(this._gridPadding,"jqplot-donutRenderer-highlight-canvas",this._plotDimensions));var n=this.plugins.donutRenderer.highlightCanvas.setContext()}e.jqplot.preInitHooks.push(c);e.jqplot.DonutTickRenderer=function(){e.jqplot.AxisTickRenderer.call(this)};e.jqplot.DonutTickRenderer.prototype=new e.jqplot.AxisTickRenderer();e.jqplot.DonutTickRenderer.prototype.constructor=e.jqplot.DonutTickRenderer})(jQuery);