/**
 * Copyright (c) 2009 - 2010 Chris Leonello
 * jqPlot is currently available for use in all personal or commercial projects 
 * under both the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL 
 * version 2.0 (http://www.gnu.org/licenses/gpl-2.0.html) licenses. This means that you can 
 * choose the license that best suits your project and use it accordingly. 
 *
 * Although not required, the author would appreciate an email letting him 
 * know of any substantial use of jqPlot.  You can reach the author at: 
 * chris dot leonello at gmail dot com or see http://www.jqplot.com/info.php .
 *
 * If you are feeling kind and generous, consider supporting the project by
 * making a donation at: http://www.jqplot.com/donate.php .
 *
 * jqPlot includes date instance methods and printf/sprintf functions by other authors:
 *
 * Date instance methods contained in jqplot.dateMethods.js:
 *
 *     author Ken Snyder (ken d snyder at gmail dot com)
 *     date 2008-09-10
 *     version 2.0.2 (http://kendsnyder.com/sandbox/date/)     
 *     license Creative Commons Attribution License 3.0 (http://creativecommons.org/licenses/by/3.0/)
 *
 * JavaScript printf/sprintf functions contained in jqplot.sprintf.js:
 *
 *     version 2007.04.27
 *     author Ash Searle
 *     http://hexmen.com/blog/2007/03/printf-sprintf/
 *     http://hexmen.com/js/sprintf.js
 *     The author (Ash Searle) has placed this code in the public domain:
 *     "This code is unrestricted: you are free to use it however you like."
 * 
 */
(function(e){e.jqplot.FunnelRenderer=function(){e.jqplot.LineRenderer.call(this)};e.jqplot.FunnelRenderer.prototype=new e.jqplot.LineRenderer();e.jqplot.FunnelRenderer.prototype.constructor=e.jqplot.FunnelRenderer;e.jqplot.FunnelRenderer.prototype.init=function(p,t){this.padding={top:20,right:20,bottom:20,left:20};this.sectionMargin=6;this.fill=true;this.shadowOffset=2;this.shadowAlpha=0.07;this.shadowDepth=5;this.highlightMouseOver=true;this.highlightMouseDown=false;this.highlightColors=[];this.widthRatio=0.2;this.lineWidth=2;this.tickRenderer=e.jqplot.FunnelTickRenderer;if(p.highlightMouseDown&&p.highlightMouseOver==null){p.highlightMouseOver=false}e.extend(true,this,p);this._highlightedPoint=null;this._bases=[];this._atot;this._areas=[];this._lengths=[];this._angle;this._unorderedData=e.extend(true,[],this.data);this.data.sort(function(v,u){return u[1]-v[1]});if(this.highlightColors.length==0){for(var r=0;r<this.seriesColors.length;r++){var q=e.jqplot.getColorComponents(this.seriesColors[r]);var n=[q[0],q[1],q[2]];var s=n[0]+n[1]+n[2];for(var o=0;o<3;o++){n[o]=(s>570)?n[o]*0.8:n[o]+0.4*(255-n[o]);n[o]=parseInt(n[o],10)}this.highlightColors.push("rgb("+n[0]+","+n[1]+","+n[2]+")")}}t.postParseOptionsHooks.addOnce(l);t.postInitHooks.addOnce(g);t.eventListenerHooks.addOnce("jqplotMouseMove",a);t.eventListenerHooks.addOnce("jqplotMouseDown",b);t.eventListenerHooks.addOnce("jqplotMouseUp",k);t.eventListenerHooks.addOnce("jqplotClick",f);t.eventListenerHooks.addOnce("jqplotRightClick",m);t.postDrawHooks.addOnce(h)};e.jqplot.FunnelRenderer.prototype.setGridData=function(p){var o=0;var q=[];for(var n=0;n<this.data.length;n++){o+=this.data[n][1];q.push([this.data[n][0],this.data[n][1]])}for(var n=0;n<q.length;n++){q[n][1]=q[n][1]/o}this._bases=new Array(q.length+1);this._lengths=new Array(q.length);this.gridData=q};e.jqplot.FunnelRenderer.prototype.makeGridData=function(p,q){var o=0;var r=[];for(var n=0;n<this.data.length;n++){o+=this.data[n][1];r.push([this.data[n][0],this.data[n][1]])}for(var n=0;n<r.length;n++){r[n][1]=r[n][1]/o}this._bases=new Array(r.length+1);this._lengths=new Array(r.length);return r};e.jqplot.FunnelRenderer.prototype.drawSection=function(o,q,p,t){var u=this.fill;var n=this.lineWidth;o.save();if(t){for(var s=0;s<this.shadowDepth;s++){o.save();o.translate(this.shadowOffset*Math.cos(this.shadowAngle/180*Math.PI),this.shadowOffset*Math.sin(this.shadowAngle/180*Math.PI));r()}}else{r()}function r(){o.beginPath();o.fillStyle=p;o.strokeStyle=p;o.lineWidth=n;o.moveTo(q[0][0],q[0][1]);for(var v=1;v<4;v++){o.lineTo(q[v][0],q[v][1])}o.closePath();if(u){o.fill()}else{o.stroke()}}if(t){for(var s=0;s<this.shadowDepth;s++){o.restore()}}o.restore()};e.jqplot.FunnelRenderer.prototype.draw=function(E,z,H){var U;var I=(H!=undefined)?H:{};var u=0;var t=0;var O=1;this._areas=[];if(H.legendInfo&&H.legendInfo.placement=="inside"){var L=H.legendInfo;switch(L.location){case"nw":u=L.width+L.xoffset;break;case"w":u=L.width+L.xoffset;break;case"sw":u=L.width+L.xoffset;break;case"ne":u=L.width+L.xoffset;O=-1;break;case"e":u=L.width+L.xoffset;O=-1;break;case"se":u=L.width+L.xoffset;O=-1;break;case"n":t=L.height+L.yoffset;break;case"s":t=L.height+L.yoffset;O=-1;break;default:break}}var s=(O==1)?this.padding.left+u:this.padding.left;var D=(O==1)?this.padding.top+t:this.padding.top;var J=(O==-1)?this.padding.right+u:this.padding.right;var o=(O==-1)?this.padding.bottom+t:this.padding.bottom;var M=(I.shadow!=undefined)?I.shadow:this.shadow;var q=(I.showLine!=undefined)?I.showLine:this.showLine;var A=(I.fill!=undefined)?I.fill:this.fill;var F=E.canvas.width;var K=E.canvas.height;this._bases[0]=F-s-J;var G=this._length=K-D-o;var r=this._bases[0]*this.widthRatio;this._atot=G/2*(this._bases[0]+this._bases[0]*this.widthRatio);this._angle=Math.atan((this._bases[0]-r)/2/G);for(U=0;U<z.length;U++){this._areas.push(z[U][1]*this._atot)}var C,W,T,N=0;var n=0.0001;for(U=0;U<this._areas.length;U++){C=this._areas[U]/this._bases[U];W=999999;this._lengths[U]=C;T=0;while(W>this._lengths[U]*n&&T<100){this._lengths[U]=this._areas[U]/(this._bases[U]-this._lengths[U]*Math.tan(this._angle));W=Math.abs(this._lengths[U]-C);this._bases[U+1]=this._bases[U]-(2*this._lengths[U]*Math.tan(this._angle));C=this._lengths[U];T++}N+=this._lengths[U]}this._vertices=new Array(z.length);var aa=[s,D],Z=[s+this._bases[0],D],Y=[s+(this._bases[0]-this._bases[this._bases.length-1])/2,D+this._length],X=[Y[0]+this._bases[this._bases.length-1],Y[1]];function S(ac){var x=(aa[1]-Y[1])/(aa[0]-Y[0]);var v=aa[1]-x*aa[0];var ad=ac+aa[1];return[(ad-v)/x,ad]}function B(ac){var x=(Z[1]-X[1])/(Z[0]-X[0]);var v=Z[1]-x*Z[0];var ad=ac+Z[1];return[(ad-v)/x,ad]}var Q=u,P=t;var V=0,p=0;for(U=0;U<z.length;U++){this._vertices[U]=new Array();var R=this._vertices[U];var w=this.sectionMargin;if(U==0){p=0}if(U==1){p=w/3}else{if(U>0&&U<z.length-1){p=w/2}else{if(U==z.length-1){p=2*w/3}}}R.push(S(V+p));R.push(B(V+p));V+=this._lengths[U];if(U==0){p=-2*w/3}else{if(U>0&&U<z.length-1){p=-w/2}else{if(U==z.length-1){p=0}}}R.push(B(V+p));R.push(S(V+p))}if(this.shadow){var ab="rgba(0,0,0,"+this.shadowAlpha+")";for(var U=0;U<z.length;U++){this.renderer.drawSection.call(this,E,this._vertices[U],ab,true)}}for(var U=0;U<z.length;U++){this.renderer.drawSection.call(this,E,this._vertices[U],this.seriesColors[U])}};e.jqplot.FunnelAxisRenderer=function(){e.jqplot.LinearAxisRenderer.call(this)};e.jqplot.FunnelAxisRenderer.prototype=new e.jqplot.LinearAxisRenderer();e.jqplot.FunnelAxisRenderer.prototype.constructor=e.jqplot.FunnelAxisRenderer;e.jqplot.FunnelAxisRenderer.prototype.init=function(n){this.tickRenderer=e.jqplot.FunnelTickRenderer;e.extend(true,this,n);this._dataBounds={min:0,max:100};this.min=0;this.max=100;this.showTicks=false;this.ticks=[];this.showMark=false;this.show=false};e.jqplot.FunnelLegendRenderer=function(){};e.jqplot.FunnelLegendRenderer.prototype.init=function(n){this.numberRows=null;this.numberColumns=null;e.extend(true,this,n)};e.jqplot.FunnelLegendRenderer.prototype.draw=function(){var q=this;if(this.show){var y=this._series;var B="position:absolute;";B+=(this.background)?"background:"+this.background+";":"";B+=(this.border)?"border:"+this.border+";":"";B+=(this.fontSize)?"font-size:"+this.fontSize+";":"";B+=(this.fontFamily)?"font-family:"+this.fontFamily+";":"";B+=(this.textColor)?"color:"+this.textColor+";":"";this._elem=e('<table class="jqplot-table-legend" style="'+B+'"></table>');var F=false,x=false,n,v;var z=y[0];var o=new e.jqplot.ColorGenerator(z.seriesColors);if(z.show){var G=z.data;if(this.numberRows){n=this.numberRows;if(!this.numberColumns){v=Math.ceil(G.length/n)}else{v=this.numberColumns}}else{if(this.numberColumns){v=this.numberColumns;n=Math.ceil(G.length/this.numberColumns)}else{n=G.length;v=1}}var E,D,p,t,r,u,w,C;var A=0;for(E=0;E<n;E++){if(x){p=e('<tr class="jqplot-table-legend"></tr>').prependTo(this._elem)}else{p=e('<tr class="jqplot-table-legend"></tr>').appendTo(this._elem)}for(D=0;D<v;D++){if(A<G.length){u=this.labels[A]||G[A][0].toString();C=o.next();if(!x){if(E>0){F=true}else{F=false}}else{if(E==n-1){F=false}else{F=true}}w=(F)?this.rowSpacing:"0";t=e('<td class="jqplot-table-legend" style="text-align:center;padding-top:'+w+';"><div><div class="jqplot-table-legend-swatch" style="border-color:'+C+';"></div></div></td>');r=e('<td class="jqplot-table-legend" style="padding-top:'+w+';"></td>');if(this.escapeHtml){r.text(u)}else{r.html(u)}if(x){r.prependTo(p);t.prependTo(p)}else{t.appendTo(p);r.appendTo(p)}F=true}A++}}}}return this._elem};e.jqplot.FunnelLegendRenderer.prototype.pack=function(q){if(this.show){var p={_top:q.top,_left:q.left,_right:q.right,_bottom:this._plotDimensions.height-q.bottom};if(this.placement=="inside"){switch(this.location){case"nw":var o=p._left+this.xoffset;var n=p._top+this.yoffset;this._elem.css("left",o);this._elem.css("top",n);break;case"n":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=p._top+this.yoffset;this._elem.css("left",o);this._elem.css("top",n);break;case"ne":var o=q.right+this.xoffset;var n=p._top+this.yoffset;this._elem.css({right:o,top:n});break;case"e":var o=q.right+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({right:o,top:n});break;case"se":var o=q.right+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({right:o,bottom:n});break;case"s":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"sw":var o=p._left+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"w":var o=p._left+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({left:o,top:n});break;default:var o=p._right-this.xoffset;var n=p._bottom+this.yoffset;this._elem.css({right:o,bottom:n});break}}else{switch(this.location){case"nw":var o=this._plotDimensions.width-p._left+this.xoffset;var n=p._top+this.yoffset;this._elem.css("right",o);this._elem.css("top",n);break;case"n":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=this._plotDimensions.height-p._top+this.yoffset;this._elem.css("left",o);this._elem.css("bottom",n);break;case"ne":var o=this._plotDimensions.width-q.right+this.xoffset;var n=p._top+this.yoffset;this._elem.css({left:o,top:n});break;case"e":var o=this._plotDimensions.width-q.right+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({left:o,top:n});break;case"se":var o=this._plotDimensions.width-q.right+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({left:o,bottom:n});break;case"s":var o=(q.left+(this._plotDimensions.width-q.right))/2-this.getWidth()/2;var n=this._plotDimensions.height-q.bottom+this.yoffset;this._elem.css({left:o,top:n});break;case"sw":var o=this._plotDimensions.width-p._left+this.xoffset;var n=q.bottom+this.yoffset;this._elem.css({right:o,bottom:n});break;case"w":var o=this._plotDimensions.width-p._left+this.xoffset;var n=(q.top+(this._plotDimensions.height-q.bottom))/2-this.getHeight()/2;this._elem.css({right:o,top:n});break;default:var o=p._right-this.xoffset;var n=p._bottom+this.yoffset;this._elem.css({right:o,bottom:n});break}}}};function c(r,q,o){o=o||{};o.axesDefaults=o.axesDefaults||{};o.legend=o.legend||{};o.seriesDefaults=o.seriesDefaults||{};var n=false;if(o.seriesDefaults.renderer==e.jqplot.FunnelRenderer){n=true}else{if(o.series){for(var p=0;p<o.series.length;p++){if(o.series[p].renderer==e.jqplot.FunnelRenderer){n=true}}}}if(n){o.axesDefaults.renderer=e.jqplot.FunnelAxisRenderer;o.legend.renderer=e.jqplot.FunnelLegendRenderer;o.legend.preDraw=true;o.sortData=false}}function g(p,o,n){for(i=0;i<this.series.length;i++){if(this.series[i].renderer.constructor==e.jqplot.FunnelRenderer){if(this.series[i].highlightMouseOver){this.series[i].highlightMouseDown=false}}}this.target.bind("mouseout",{plot:this},function(q){j(q.data.plot)})}function l(n){for(var o=0;o<this.series.length;o++){this.series[o].seriesColors=this.seriesColors;this.series[o].colorGenerator=this.colorGenerator}}function d(r,q,p){var o=r.series[q];var n=r.plugins.funnelRenderer.highlightCanvas;n._ctx.clearRect(0,0,n._ctx.canvas.width,n._ctx.canvas.height);o._highlightedPoint=p;r.plugins.funnelRenderer.highlightedSeriesIndex=q;o.renderer.drawSection.call(o,n._ctx,o._vertices[p],o.highlightColors[p],false)}function j(p){var n=p.plugins.funnelRenderer.highlightCanvas;n._ctx.clearRect(0,0,n._ctx.canvas.width,n._ctx.canvas.height);for(var o=0;o<p.series.length;o++){p.series[o]._highlightedPoint=null}p.plugins.funnelRenderer.highlightedSeriesIndex=null;p.target.trigger("jqplotDataUnhighlight")}function a(r,q,u,t,s){if(t){var p=[t.seriesIndex,t.pointIndex,t.data];var o=jQuery.Event("jqplotDataMouseOver");o.pageX=r.pageX;o.pageY=r.pageY;s.target.trigger(o,p);if(s.series[p[0]].highlightMouseOver&&!(p[0]==s.plugins.funnelRenderer.highlightedSeriesIndex&&p[1]==s.series[p[0]]._highlightedPoint)){var n=jQuery.Event("jqplotDataHighlight");n.pageX=r.pageX;n.pageY=r.pageY;s.target.trigger(n,p);d(s,p[0],p[1])}}else{if(t==null){j(s)}}}function b(q,p,t,s,r){if(s){var o=[s.seriesIndex,s.pointIndex,s.data];if(r.series[o[0]].highlightMouseDown&&!(o[0]==r.plugins.funnelRenderer.highlightedSeriesIndex&&o[1]==r.series[o[0]]._highlightedPoint)){var n=jQuery.Event("jqplotDataHighlight");n.pageX=q.pageX;n.pageY=q.pageY;r.target.trigger(n,o);d(r,o[0],o[1])}}else{if(s==null){j(r)}}}function k(p,o,s,r,q){var n=q.plugins.funnelRenderer.highlightedSeriesIndex;if(n!=null&&q.series[n].highlightMouseDown){j(q)}}function f(q,p,t,s,r){if(s){var o=[s.seriesIndex,s.pointIndex,s.data];var n=jQuery.Event("jqplotDataClick");n.pageX=q.pageX;n.pageY=q.pageY;r.target.trigger(n,o)}}function m(r,q,u,t,s){if(t){var p=[t.seriesIndex,t.pointIndex,t.data];var n=s.plugins.funnelRenderer.highlightedSeriesIndex;if(n!=null&&s.series[n].highlightMouseDown){j(s)}var o=jQuery.Event("jqplotDataRightClick");o.pageX=r.pageX;o.pageY=r.pageY;s.target.trigger(o,p)}}function h(){this.plugins.funnelRenderer={};this.plugins.funnelRenderer.highlightCanvas=new e.jqplot.GenericCanvas();this.eventCanvas._elem.before(this.plugins.funnelRenderer.highlightCanvas.createElement(this._gridPadding,"jqplot-funnelRenderer-highlight-canvas",this._plotDimensions));var n=this.plugins.funnelRenderer.highlightCanvas.setContext()}e.jqplot.preInitHooks.push(c);e.jqplot.FunnelTickRenderer=function(){e.jqplot.AxisTickRenderer.call(this)};e.jqplot.FunnelTickRenderer.prototype=new e.jqplot.AxisTickRenderer();e.jqplot.FunnelTickRenderer.prototype.constructor=e.jqplot.FunnelTickRenderer})(jQuery);